package 
{
	import com.bit101.components.ComboBox;
	import com.bit101.components.Label;
	import com.bit101.components.PushButton;
	import com.bit101.components.RadioButton;
	import com.bit101.components.TextArea;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.text.TextField;
	import flash.text.TextFieldType;
	import flash.text.TextFormat;
	
	/**
	 * ...
	 * @author phillip.ahn@thecreativeshop.com.au
	 */
	[SWF(width="540", height="350", frameRate="30", backgroundColor="#EEEEEE")]
	public class Main extends Sprite 
	{
		private var _reg:RadioButton;
		private var _for:RadioButton;
		private var _test:PushButton;
		private var _comment:TextArea;
		private var _keyword:TextArea;
		private var _commentText:String;
		private var _reset:PushButton;
		private var _running:Label;
		private var _double:ComboBox;
		
		
		public function Main():void 
		{
			if (stage) init();
			else addEventListener(Event.ADDED_TO_STAGE, init);
		}
		
		private function init(e:Event = null):void 
		{
			removeEventListener(Event.ADDED_TO_STAGE, init);
			// entry point
			addChild( new Label(this, 10, 5, 'Offensive Word'));
			addChild( new Label(this, 10, 30, 'Comment'));
			addChild( new Label(this, 540/2+5, 30, 'Keyword'));
			
			_commentText = 'Google Inc. is an American multinational public corporation invested in Internet search, cloud computing, and advertising technologies. Google hosts and develops a number of Internet-based services and products,[4] and generates profit primarily from advertising through its AdWords program';
			_commentText += '\n\r';
			_commentText += 'Naver is a popular search portal in South Korea, with a market share of over 70%, compared to 2% of Google.[1] Naver was launched in June 1999 by ex-Samsung employees, and it debuted as the first Web portal in South Korea that used its own proprietary search engine.';
			_commentText += '\n\r';
			_commentText += 'Yahoo! Inc. (NASDAQ: YHOO) is an American public corporation with headquarters in Sunnyvale, California, (in Silicon Valley), that provides services via the Internet worldwide. The company is perhaps best known for its web portal, search engine (Yahoo! Search), Yahoo! Directory, Yahoo! Mail, Yahoo! News, advertising, online mapping (Yahoo! Maps), video sharing (Yahoo! Video), and social media websites and services.';
			
			_comment = new TextArea;
			_comment.x = 10;
			_comment.y = 50;
			_comment.width = 510 / 2;
			_comment.height = 200;
			_comment.text = _commentText;
			_comment.editable = false;
			addChild(_comment);
			
			_keyword = new TextArea;
			_keyword.x = 540/2+5;
			_keyword.y = 50;
			_keyword.width = 510 / 2;
			_keyword.height = 200;
			_keyword.text = 'google,naver,yahoo';
			addChild(_keyword);
			
			_double = new ComboBox(this, 10, 265, 'double', [1, 2, 3, 5, 15, 20, 50, 100]);
			_double.numVisibleItems = 3;
			_double.addEventListener(Event.SELECT, handleDouble);
			addChild(_double);
			
			_reg = new RadioButton(this, 320, 270, 'REG');
			_reg.selected = true;
			_reg.addEventListener(MouseEvent.CLICK, handleRadio);
			addChild(_reg);
			
			_for = new RadioButton(this, 370, 270, 'FOR');
			_for.addEventListener(MouseEvent.CLICK, handleRadio);
			addChild(_for);
			
			_test = new PushButton(this, 420, 265, 'TEST');
			_test.addEventListener(MouseEvent.CLICK, handleTest);
			addChild(_test);
			
			_running = new Label(this, 420, 295, 'running : ');
			addChild(_running);
			
			//_reset = new PushButton(this, 330, 265, 'Reset');
			//_reset.addEventListener(MouseEvent.CLICK, handleReset);
		}
		
		private function handleRadio(e:MouseEvent):void 
		{
			_comment.text = _comment.text;
		}
		
		private function handleDouble(e:Event):void 
		{
			var d:int = _double.selectedItem as int;
			_comment.text = '';
			for (var i:int = 0; i < d+1; i++) {
				_comment.text += _commentText;
			}
		}
		
		private function handleReset(e:MouseEvent):void 
		{
			_comment.text = _commentText;
		}
		
		private function handleTest(e:MouseEvent):void 
		{
			var start:Number = new Date().getTime();
			if (_reg.selected) {
				checkByReg(_comment.text, _keyword.text.split(','));
			} else {
				checkByFor(_comment.text, _keyword.text.split(','));
			}
			var running:Number = new Date().getTime() - start;
			var format:Date = new Date(running);
			_running.text = 'running : '+format.seconds+'.'+addZero(format.milliseconds, 3);
		}
		
		private function checkByReg(input:String, keyword:Array):void
		{
			var temp:String = input;
			for (var i:int = 0; i < keyword.length; i++)
			{
				var pattern:RegExp = new RegExp('(' + keyword[i] + ')', 'ig');
				temp = temp.replace(pattern, '<font color="#ff0000">$&</font>');
			}
			
			_comment.textField.htmlText = temp;
		}
		
		public function checkByFor(input:String, keyword:Array):void
		{
			var format:TextFormat = new TextFormat(null, null, 0xFF0000);
			
			for ( var i:int = 0 ; i < input.length ; i++ )
			{
				for ( var j:int = 0 ; j < keyword.length ; j++ )
				{
					var badWord:String = keyword[j];
					
					if ( checkWord(i, input, badWord) )
					{
						_comment.textField.setTextFormat(format, i, i + badWord.length);
					}
				}
			}
		}
		
		private function checkWord(index:int, input:String, badWord:String):Boolean
		{
			for ( var i:int = 0 ; i < badWord.length ; i++ )
			{
				var currentCharOfBadWord:String = badWord.charAt(i).toUpperCase();
				var currentCharOfInput:String = input.charAt(index + i).toUpperCase();
				
				if ( currentCharOfBadWord != currentCharOfInput )
					return false;
			}
			
			return true;
		}
		
		public function addZero( $number:Number, $offset:int=2 ):String
		{
			var strAdd:String = "";
			var numLen:int 	= int( String($number).length )
			
			for ( var i:int = 0; i < $offset; i++ )
			{
				if ( i >= numLen ) strAdd += "0";
			}
			
			strAdd += $number;	
			
			return strAdd;
		}
	}
	
}